<template>
    <section class="section" :class="classes">
        <slot></slot>
        <div class="section__scheme-switcher" v-if="showSwitcher && showSwitch">
            <button :class="{active: scheme_ == key}" @click="scheme_ = key" v-for="(type, key) in types" :key="key">{{ type }}</button>
        </div>
        <div class="section__buttons container" :class="{'section__buttons-mode-text' : buttons_text && buttons.length == 1 }" v-if="buttons_">
            <p v-if="buttons_text">{{ buttons_text }}</p>
            <btn :href="button.link.url" :target="button.link.target" :color="button.color" v-for="(button, index) of buttons_" :key="index">{{ button.link.title }}</btn>
        </div>
    </section>
</template>

<script>
export default {
    props: {
        scheme: {
            type: String,
            default: 'white'
        },
        type: {
            type: String
        },
        buttons: {
            // type: Array,
            default: null
        },
        showSwitch: {
            type: Boolean,
            default: true
        },
        params: {
            type: Object,
            default: () => ({}),
        },
        buttons_text: {
           default: null 
        }
    },
    data() {
        return {
            scheme_: this.params.scheme || this.scheme,
            buttons_: this.params.buttons || this.buttons,
            types: {
                white:  'White',
                light:  'Light',
                dark:   'Dark'
            }
        }
    },
    computed: {
        showSwitcher: () => {
            return window.env && window.env.ENV == 'local'
        },
        classes: function(){
            return {
                [`section-${this.type}`]                     : this.type,
                [`section--${this.scheme_}`]                 : this.scheme_,
                [`section-${this.type}--${this.scheme_}`]    : this.type && this.scheme_,
            }
        }
    }
}
</script>